#include "ledblink.h"
#include "settings.h"

/*================================================================================================*/
#define LED_PIN         SET_PIN_LED_DEBUG
#define LED_PINVAL_ON   1
/*================================================================================================*/

/*================================================================================================*/
static uint32_t f_led_mode, f_led_timer;
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
void ledblink_init(void)
    {
    f_led_mode = LEDBLINK_MODE_STEADY(0);
    LPC_PIN_CONFIG(LED_PIN, 0, LPC_PIN_NOPULL);
    LPC_PIN_OUT(LED_PIN, !LED_PINVAL_ON);
    LPC_PIN_DIR_OUT(LED_PIN);
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void ledblink_setmode(uint32_t mode)
    {
    if (mode & LEDBLINK_MODE_STEADY_MSK)
        {
        LPC_PIN_OUT(LED_PIN, !LED_PINVAL_ON ^ (mode & 1));
        }
    else if (f_led_mode != mode)
        {
        LPC_PIN_OUT(LED_PIN, LED_PINVAL_ON);
        f_led_timer = microtimer_now();
        }
    f_led_mode = mode;
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void ledblink_worker(void)
    {
    if (!(f_led_mode & LEDBLINK_MODE_STEADY_MSK))
        {
        uint32_t t = microtimer_now();
        if ((uint32_t)(t - f_led_timer) >= f_led_mode)
            {
            LPC_PIN_TOGGLE(LED_PIN);
            f_led_timer = t;
            }
        }
    }
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
